#include <iostream>
#include <math.h>

using namespace std;

int* remainders;
int* period;

void PresSignOfFrac(int &k, int &sign);
int IfIsInRemainders(int rem, int len);
void ReductionOfFractions(int &a, int &b, int &min);

int main()
{
	int a, b, len = 1, sign = 1, rem, at, bt, min;
	cout << "Input numbers a and b separated by a space: ";
	cin >> a >> b;
	if (b == 0) {
		cout << "Error! b = 0";
		return 1;
	} 

	remainders = new int[abs(b) + 1];
	period = new int[abs(b) + 1];

	PresSignOfFrac(a, sign);
	PresSignOfFrac(b, sign);
	
	if (a < b)
		min = a;
	else min = b;
	
	ReductionOfFractions(a, b, min);

	at = a;
	bt = b;
	do {
		rem = at % bt;
		remainders[len] = rem;
		period[len] = at / bt;
		at = 10 * rem;
		len++;
	}
	while(IfIsInRemainders(rem, len) == 0);

	if (len == 3 && period[2] == 0)
		cout << sign * ((a * 1.) / (b * 1.));
	else {
		if (a / b == 0)
			cout << sign * a << "/" << b;
		else cout << sign * a / b << " " << a - (a / b) * b << "/" << b;
	}

	delete[] remainders;
	delete[] period;
	return 0;
}

void PresSignOfFrac(int &k, int &sign) 
{
	if (k < 0) {
		sign *= -1;
		k = abs(k);
	}
	else ;
}

int IfIsInRemainders(int rem, int len)
{
	for(int i = 1; i < len - 1; i++)
		if (remainders[i] == rem)
			return i;
		else ;
	return 0;
}

void ReductionOfFractions(int &a, int &b, int &min) 
{
	if (a == b) {
		a = 1;
		b = 1;
	}
	else {
		for (int i = 2; (i <= min / 2 || i <= 2); i++) {
			if (a % i == 0 && b % i == 0) {
				a /= i;
				b /= i;
				min /= i;
				ReductionOfFractions(a, b, min);
				break;
			}
			else ;
		}
	}
}
